/***************************************************************************
                               configfile.cpp
                             -------------------                                         
    begin                : Thu Nov 11 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "configfile.h"

ConfigFile::ConfigFile(const char *root, const char *name)
: path(root)
{
    path += name;
    data = 0;
    count = 0;
}

ConfigFile::~ConfigFile()
{
    char	**p;
//BUGGY MESSAGE
    for (p = data; p && *p; p++)
	free(*p);
    free(data);

}

bool ConfigFile::mkdirp(QString path)
{
    if (::mkdir(path.ascii(), 0755) >= 0 || errno == EEXIST){
			printf( "mkdir %s\n", path.ascii() );
			return true;
		}
    if (errno == ENOENT) {
			int	i;

			i = path.findRev('/');
			if (i > 0 && mkdirp(path.left(i))) {
	  	  if (::mkdir(path.ascii(), 0755) >= 0){
					printf( "mkdir %s\n", path.ascii() );
					return true;
				}
			}
    }
    return false;
}

FILE *ConfigFile::open(const char *mode)
{
    QString dir;
    FILE    *fp;

    if ( strchr("wa", *mode ) && !mkdirp(path.left(path.findRev('/'))) )
        return 0;

    if( !(fp = fopen(path.ascii(), mode)) )
      printf( "Unable to open %s (mode %s): %m\n", path.ascii(), mode );

    return fp;
}

bool ConfigFile::load()
{
    char	buffer[1024], *sp;
    FILE	*fp;

    fp = open( "r" );
    if( fp == NULL )
			return true;

    while (fgets(buffer, sizeof(buffer), fp) != NULL) {
			if ((sp = strchr(buffer, '\n')) != '\0')
	  	  *sp = '\0';
			if (!append(buffer)) {
	  	  printf( "Out of memory when loading %s\n", path.ascii() );
	    	fclose(fp);
		    return false;
			}
    }

    fclose(fp);
    return true;
}

bool ConfigFile::append(const char *line)
{
    if ((count % 16) == 0) {
        // plus one for the NULL pointer
        data = (char **) realloc(data, (count+16+1) * sizeof(char *));
        if (data == 0)
	    return false;
    }
    data[count] = strdup(line);
    if (data[count] == 0)
        return false;
    data[++count] = 0;
    return true;
}

bool ConfigFile::save(void)
{
    FILE	*fp;
    char	**sp;

    fp = open("w");
    if (fp == 0)
	return false;
    for (sp = data; sp && *sp; sp++) {
	fprintf(fp, "%s\n", *sp);
    }
    fclose(fp);
    return true;
}





