/***************************************************************************
                                 diskitem.h
                             -------------------                                         
    begin                : Mon Dec 20 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DISKITEM_H
#define DISKITEM_H

#include "config.h"
#include "diskorpartitionitem.h"

#include <qcombobox.h>

#include "partitionitem.h"
#include "changepartitiondialog.h"
/*class PartitionItem;
class ChangePartitionDialog;*/



class DiskItem : public QObject, public DiskOrPartitionItem {
    Q_OBJECT
public:
    DiskItem( const QString& disk_, QListView* parent, ChangePartitionDialog* dialog );
    ~DiskItem();

    bool isDisk() { return TRUE; }

    void insertPartition( const QString& line );

    QString disk;

    PartitionItem* findPartition( int sector );
    bool hasExtendedPartition();
    PartitionItem* extendedPartition();

    void renumberLogicalPartitions();

    int heads;
    int sectors;
    int cylinders;
    double capacity();
    int cylinderOfSector( int );
    int sectorOfCylinder( int );

    int nrPrimary;

    double megaByteOfSectors( int );

    bool verifyFreeSpacesPrimary( double start, double end, double empty );
    bool verifyFreeSpacesLogical( double start, double end, double empty );

    PartitionItem* partition( int number);

    void invalidateDisk();

public slots:
    bool edit( PartitionItem* );
    bool addLogicalPartition();
    void removeOrClear( PartitionItem* );

    bool writePartitionTable();
    void defaultPartitionTable();

    void doAutoPartitioning();

private:

    void getFreeSpace( int number, double& start, double& size);
    PartitionItem* primaryPartition( int number );

    void fillFreeSpacesPrimary( QComboBox* freeSpaces, double empty );
    void insertFreeSpace( QComboBox* freeSpaces, double start, double after);
    PartitionItem* firstNonEmptyPrimary( double empty );
    PartitionItem* nextNonEmptyPrimary(double start, double empty);

    void fillFreeSpacesLogical( QComboBox* freeSpaces, double empty );
    PartitionItem* firstLogical( double empty );
    PartitionItem* nextLogical(double start, double empty);

    ChangePartitionDialog* partitionDialog;

    QString partitions;
    void initPartitionTable();

    bool valid;
    bool changed;
    bool original;


};

#endif
