/***************************************************************************
                          grub.h  -  description
                             -------------------
    begin                : Sat Oct 29 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Anisimov
    author email         : aa@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GRUB_H
#define GRUB_H

#include "fdisk.h"

#include <qwidget.h>
#include <qframe.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qcombobox.h>
#include <qlabel.h>

class PartitionView;

class GRUBInfoItem : QCheckListItem
{
public:

  GRUBInfoItem(QListView *parent, bool active, const QString &partition,
		const QString &type, const QString &label);
  ~GRUBInfoItem();

};


class GRUB: public QWidget
{
  Q_OBJECT

public:

	GRUB( PartitionView *pv, QWidget *parent, const char *name=0 );
  ~GRUB();

  void init();

  void finish( bool a_addRunLevel5 = true );
  int createBootdisk( bool a_addRunlevel5 );

protected slots:

  void targetChanged(int index);
  void diskChanged(const QString &disk);
 
private:
  char szIinitrdImage[ 50 ];
  bool useInitrd;
  int mkinitrd( const char *a_szPrefix, const char * a_szKernelVersion, const char * a_szInitrdImage );
  int CreateInitrdImage( const char *a_szRootPath, const char *a_szKernelVersion );
  int link_file( int a_iSMP, const char *a_szKernelPrefix, const char *a_szKernelVersion, const char *a_szFileName, const char *a_szMapAs );
  int link_boot_files( int a_iSMP, const char *a_szKernelPrefix, const char *a_szKernelVersion );
  char *ConvLinuxDev2GRUB(char *, const char *);
  int GoodOldLILOConfWrite( );
  int writeConfFile( QString a_QSConfFilePath, bool a_addRunlevel5 );
  int runProgramIORoot( char * root, char * name, char ** args );
  QString lastVersionName( QString a_QFindPath, QString a_QVersionNumber );
  QString lastVersion( QString a_QFindPath, QString a_QVersionNumber );
  int makeBootdisk(char * prefix, char * kernelVersion);
	int askToSwitchToMBR( int new_index );

  QRadioButton *mbr, *target, *other, *no_grub;
  QLineEdit *otherDest;
  QComboBox *disks;
  QLabel *diskinfo;

  QListView *list;

  PartitionView *pview;

	bool addRunlevel5;
  int can_do_smp;
  int WriteConfigFileFlag;
  int makeBootDiskPid;

	bool firstTimeMBRWarning;
};


#endif





