/***************************************************************************
                              installselect.cpp
                             -------------------
    begin                : Sat Oct 29 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "installselect.h"
#include "log.h"
#include "windows.h"
#include "smp.h"
#include "syslog.h"
#include "config.h"
#include "packagelistitem.h"
#include "mountpoint.h"

#include "gblidebug.h"

#include <iostream.h>
#include <stdio.h>
#include <qdir.h>
#include <signal.h>
#include <sys/time.h>
#include <unistd.h>

#define FILENAME_TAG 1000000
int curTemp;
long curInstalled;

char * skipList[] = { "XFree86-8514", "XFree86-AGX", "XFree86-Mach32",
		      "XFree86-Mach64", "XFree86-Mach8", "XFree86-Mono",
		      "XFree86-P9000", "XFree86-S3", "XFree86-S3V",
		      "XFree86-W32", "XFree86-I128", "XFree86-3DLabs",
		      "XFree86-Sun", "XFree86-SunMono", "XFree86-Sun24",
		      NULL };
/*
struct devnum {
    char * name;
    short major, minor;
    int isChar;
};

static struct devnum devices[] = {
    { "aztcd",		29,	0,	0 },
    { "bpcd",		41,	0,	0 },
    { "cdu31a",		15,	0,	0 },
    { "cdu535",		24,	0,	0 },
    { "cm206cd",	32,	0,	0 },
    { "fd0",     	2,	0,	0 },
    { "fd1",		2,	1,	0 },
    { "gscd",		16,	0,	0 },
    { "lp0",		6,	0,	1 },
    { "lp1",		6,	1,	1 },
    { "lp2",		6,	2,	1 },
    { "mcd",		23,	0,	0 },
    { "mcdx",		20,	0,	0 },
    { "nst0",		9,	128,	1 },
    { "optcd",		17,	0,	0 },
    { "sbpcd",		25,	0,	0 },
    { "scd0",		11,	0,	0 },
    { "scd1",		11,	1,	0 },
    { "sjcd",		18,	0,	0 },
};

int numDevices = sizeof(devices) / sizeof(struct devnum);

static int mkdirIfNone(char * directory) {
    int rc, mkerr;
    char * chptr;

    // If the file exists it *better* be a directory -- I'm not going to
    // actually check or anything
    if (!access(directory, X_OK)) return 0;

    // if the path is '/' we get ENOFILE not found" from mkdir, rather
    // then EEXIST which is weird
    for (chptr = directory; *chptr; chptr++)
      if (*chptr != '/') break;
    if (!*chptr) return 0;

    rc = mkdir(directory, 0755);
    mkerr = errno;

    Log::logMain( 2, "creating directory %s rc = %d", directory, rc );

    if (!rc || mkerr == EEXIST) return 0;

    Log::logMain( 2, "    error: %s", strerror(mkerr) );

    return INST_ERROR;
}

static int mkdirChain(char * origChain) {
    char * chain;
    char * chptr;

    chain = (char *)alloca(strlen(origChain) + 1);
    strcpy(chain, origChain);
    chptr = chain;

    while ((chptr = strchr(chptr, '/'))) {
    	*chptr = '\0';
    	if (mkdirIfNone(chain)) {
    	    *chptr = '/';
    	    return INST_ERROR;
    	}

    	*chptr = '/';
    	chptr++;
    }

    if (mkdirIfNone(chain))
			return INST_ERROR;

    return 0;
}

int devMakeInode(char * name, char * path) {
    int i;
    int major, minor;
    int type;
    char *ptr;
    char *dir;

    if (name[0] == 's' && name[1] == 'd') {
    	type = S_IFBLK;
    	major = 8;
    	minor = (name[2] - 'a') << 4;
    	if (name[3] && name[4])
   	   minor += 10 + (name[4] - '0');
    	else if (name[3])
   	   minor += (name[3] - '0');
    } else if (name[0] == 'h' && name[1] == 'd') {
    	type = S_IFBLK;
    	if (name[2] == 'a')
    	    major = 3, minor = 0;
    	else if (name[2] == 'b')
    	    major = 3, minor = 64;
    	else if (name[2] == 'c')
    	    major = 22, minor = 0;
    	else if (name[2] == 'd')
    	    major = 22, minor = 64;
    	else if (name[2] == 'e')
    	    major = 33, minor = 0;
    	else if (name[2] == 'f')
    	    major = 33, minor = 64;
    	else if (name[2] == 'g')
    	    major = 34, minor = 0;
    	else if (name[2] == 'h')
    	    major = 34, minor = 64;
    	else
    	    return INST_ERROR;

    	if (name[3] && name[4])
    	   minor += 10 + (name[4] - '0');
    	else if (name[3])
    	   minor += (name[3] - '0');
    } else if (!strncmp(name, "ram", 3)) {
    	type = S_IFBLK;
    	major = 1;
    	minor = 1;
    	if (name[3])
    	    minor += name[3] - '1';
    } else if (!strncmp(name, "rd/", 3)) {
    	// dac 960 "/rd/cXdXXpX". It can have 8 controllers, 32 drives
    	//   per controller and 7 partitions per drive.
    	char *c, *d, *p;

      type = S_IFBLK;
    	
    	// Copy "XdXXpX". Get controller #.
    	c = (char *)alloca (strlen (&name [4]) + 1);
    	strcpy (c, &name [4]);

    	// Get drive #.
    	d = c;
    	d++;
    	d++;
    	
    	// Get partition #.
    	p = d;
    	while (*p != '\0' && *p != 'p') p++;
    	
    	major = 48 + *c - '0';
    	if (*p == 'p') {
    	    // Get partition #.
    	    *p++ = '\0';
    	    minor = atoi (d) * 8 + *p - '0';
    	}
    	else {
    	    minor = atoi (d) * 8;
    	}
    } else if (!strncmp(name, "ida/", 4)) {
    	// Compaq Smart Array "ida/c0d0{p1}
    	type = S_IFBLK;
    	major = 72;                    // controller
    	minor = (name[7] - '0') * 16;  // disk
    	if (strlen(name) > 8)          // partition
   	    minor += atoi(name + 9);
    } else {
    	for (i = 0; i < numDevices; i++) {
   	    if( !strcmp(devices[i].name, name) ) break;
    	}
    	if (i == numDevices) return INST_ERROR;
    	major = devices[i].major;
    	minor = devices[i].minor;

    	if (devices[i].isChar)
   	    type = S_IFCHR;
    	else
   	    type = S_IFBLK;
    }

    // make a directory for this inode if needed.
    ptr = path;
    i = 0;
    while (*ptr)
      if (*ptr++ == '/')
        i++;
    if (i > 2) {
      dir = (char *)alloca(strlen(path) + 1);
      strcpy(dir, path);
      ptr = dir + (strlen(path) - 1);
      while (*ptr != '/')
        *ptr-- = '\0';
      mkdir(dir, 0755);
    }

    unlink(path);
    if( mknod(path, type | 0600, makedev(major, minor)) ) {
			printf( "mknod() failed %s\n", strerror(errno));
			return INST_ERROR;
    }else{
			printf( "created device file %s\n", path );
		}

    return 0;
}

void devRemoveInode(char * path) {
		printf( "removing device file %s", path );
    unlink(path);
}

int doPwMount(char * dev, char * where, char * fs, int rdonly, char * acct, char * pw);

int doMount(char * dev, char * where, char * fs, int rdonly ) {
	  return doPwMount(dev, where, fs, rdonly, NULL, NULL);
}

int doPwMount(char * dev, char * where, char * fs, int rdonly, char * acct, char * pw) {
    char * buf = NULL;
    int isnfs = 0;
    char * mount_opt = NULL;
    long int flag;

    if( !strcmp( fs, "nfs" ) ) isnfs = 1;

    Log::logMain( 1, "mounting %s on %s as type %s", dev, where, fs );

		mkdirChain(where);

  	if( !isnfs && *dev == '/' ){
	    buf = dev;
		}else if( !isnfs ){
	    buf = (char *)alloca(200);
	    strcpy( buf, "/tmp/" );
	    strcat( buf, dev );

	    if( devMakeInode(dev, buf) ) return 1;
		}
  	flag = MS_MGC_VAL;
  	if( rdonly )
 	    flag |= MS_RDONLY;

  	if( !strncmp( fs, "vfat", 4 ) )
 	    mount_opt="check=relaxed";

  	Log::logMain( 2, "calling mount(%s, %s, %s, %ld, %p)", buf, where, fs,
 			flag, mount_opt );

  	if (mount(buf, where, fs, flag, mount_opt)) {
  		fprintf(stderr, "mount failed: %s\n", strerror(errno));
 	    return 1;
  	}

  	if (!isnfs) devRemoveInode(buf);

    return 0;
}*/

static int pkgCompare( const void * first, const void * second )
{
    packageInfo ** a = (packageInfo **)first;
    packageInfo ** b = (packageInfo **)second;

    // put packages w/o names at the end
    if (!(*a)->name) return 1;
    if (!(*b)->name) return -1;

    return strcasecmp( (*a)->name, (*b)->name );
}

static int psGetArchScore( const Header h )
{
    char * pkgArch;
    int type, count;

    if( !headerGetEntry(h, RPMTAG_ARCH, &type, (void **)&pkgArch, &count) ||
        type == RPM_INT8_TYPE )
       return 150;
    else
       return rpmMachineScore( RPM_MACHTABLE_INSTARCH, pkgArch );
}

static int pkgCompareVer( const void * first, const void * second )
{
    packageInfo ** a = (packageInfo **)first;
    packageInfo ** b = (packageInfo **)second;
    int ret, score1, score2;

    // put packages w/o names at the end
    if (!(*a)->name) return 1;
    if (!(*b)->name) return -1;

    ret = strcasecmp( (*a)->name, (*b)->name );
    if (ret) return ret;
    score1 = psGetArchScore((*a)->h);
    if (!score1) return 1;
    score2 = psGetArchScore((*b)->h);
    if (!score2) return -1;
    if (score1 < score2) return -1;
    if (score1 > score2) return 1;
    return rpmVersionCompare( (*b)->h, (*a)->h );
}

static char *labels[] = {
	"Full installation (recommended)",
	"Typical installation",
	"Minimal installation",
	"Custom" };

InstallSelect::InstallSelect( QWidget * parent, const char * name )
    : QWidget( parent, name ), iStage( -1 ), selected( undefined ), currentProgress( 0 ), maxProgress( 0 )
{
		cs.numComponents = 0;
		ps.numPackages = 0;

    gb = new QButtonGroup( 0 );

    QHBoxLayout * lh = new QHBoxLayout( this, 0, 6 );

    QVBoxLayout * l = new QVBoxLayout( 6 );
		lh->addStretch( 5 );
    lh->addLayout( l, 2 );
		lh->addStretch( 5 );

    QHBoxLayout* lrh = new QHBoxLayout();
    l->addStretch();
    l->addLayout( lrh );
    l->addStretch();

    QVBoxLayout *lr = new QVBoxLayout();
    lrh->addStretch( 1 );
    lrh->addLayout( lr, 5 );
    lrh->addStretch( 1 );
		
		for( int i = 0; i < 4; i++ ){
			rbAll[i] = new QRadioButton( tr( labels[i] ), this );
			rbAll[i]->setAutoResize( true );
  	  lr->addWidget( rbAll[i], 3, AlignTop + AlignLeft );
    	gb->insert( rbAll[i], i );
		}

    connect( gb, SIGNAL(clicked(int)), this, SLOT(setSelected(int)) );
		rbAll[0]->setChecked( true );
		setSelected( full );
}

void InstallSelect::setSelected( int a_i )
{
	selected = a_i;
  withX = ( selected != base && selected != custom );
}

static int needed_space[3][9] = {
	{ 1134, 153,39, 36, 9, 6, 6, 15, 4 },  //full
	{ 767,  1,  13, 36, 7, 6, 6, 7,  4 },  //typical
	{ 100,  1,  5,  36, 5, 4, 6, 5,  2 } };//minimal

static char *dirs[] = { "/usr", "/opt", "/var", "/lib", "/bin", "/sbin",
												"/boot", "/home", "/etc" };

void InstallSelect::checkFreeSpace()
{
	MountPointList mps = MountPoints::allDirectories();

	MountPoint *mp;
	int iDirsMax = sizeof( dirs ) / sizeof( char * );
	for( int install_type = 0; install_type < 3; install_type++ ){
		int iFullSize = 0;
		for( int i = 0; i < iDirsMax; i++ )
			iFullSize += needed_space[install_type][i];
		Log::logMain( 0, "Needed space for install_type %d is %d", install_type, iFullSize );
		int iNeededRoot = iFullSize;;
		int iRootPartSize = 0;
		bool enough = true;
		if( iFullSize ){// if we don't need anything, why we need to check it, right?
  		for( mp = mps.first(); mp != NULL; mp = mps.next() ){
  			char name[128];
  			strcpy( name, mp->name().ascii() );
  			if( !strcmp( name, "/" ) ){
  				iRootPartSize = (int)(mp->free() / 0x100000);
//printf( "iRootPartSize: %d\n", iRootPartSize );
  			}else{
//printf( "partition: %s - %d\n", mp->name().ascii(), (int)(mp->free()/0x100000) );
     			for( int n = 0; n < iDirsMax; n++ )
     				if( !strcmp( dirs[n], name ) ){
  						int size = (int)(mp->free() / 0x100000);
     					enough = needed_space[install_type][n] <= size;
  						iNeededRoot -= needed_space[install_type][n];
     					break;
     				}
  			}
  			if( !enough ) break;
    	}
//printf( "iNeededRoot: %d\n", iNeededRoot );
  		if( enough ){
  			if( iRootPartSize )
  				enough = iRootPartSize >= iNeededRoot;
  			else // it's unbelievable that we come here, but still
  				enough = false;
  		}
		}else
			enough = true;
    QRadioButton *curtype = rbAll[ install_type ];
		if( iFullSize )
			curtype->setText( tr( labels[install_type] ) + "   ~"+ QString::number(iFullSize) +"MB" );
		else
			curtype->setText( tr( labels[install_type] ) );
		curtype->setEnabled( enough );
		curtype->adjustSize();
	}
	for( int i = 0; i < 4; i++ )
		if( ((QRadioButton*)rbAll[i])->isEnabled() ){
			((QRadioButton*)rbAll[i])->setChecked( true );
			setSelected( i );
			break;
		}
}

int InstallSelect::loadData()
{
	QString str = QString( RPM_PATH ) + "/base/hdlist";
	int res = INST_OK;
	if( !ps.numPackages )
		res = getPackageSet( str );
	if( res == INST_OK && !cs.numComponents ){
		str = QString( RPM_PATH ) + "/base/comps";
		res = getComponentSet( str );
	}
	return res;
}

void InstallSelect::showEvent( QShowEvent *ev )
{
	checkFreeSpace();
}

void InstallSelect::hideEvent( QHideEvent *ev )
{
}

void InstallSelect::runUpgrade()
{
  selected = upgrade;
	runInstall();
}

void InstallSelect::runInstall()
{
  emit prevEnabled( this, false );

	curInstalled = 0;

	createDirs();

//	somefile = ::open( "/mnt/root/tmp/install_spec.log", O_RDWR | O_CREAT | O_TRUNC );

  int fd[2];
  ::pipe( fd );

 	int s;
  if ( (s = fcntl( fd[0], F_GETFL, 0 ) ) >= 0 ) {
 		s |= FNDELAY;
 		fcntl( fd[0], F_SETFL, s );
  }

  notifier = new QSocketNotifier( fd[0], QSocketNotifier::Read, this );
  connect( notifier, SIGNAL( activated(int) ),
    this, SLOT( showInstallationProgress(int) ) );

  pid = ::fork();
  if( pid == 0 ) {
		::close( fd[0] );
		::close( STDERR_FILENO );
		::close( STDOUT_FILENO );

	 	if( fd[1] != STDOUT_FILENO ) {
			int res = -1;
   	  res = dup2( fd[1], STDOUT_FILENO );
		 	if( res >= 0 && fd[1] != STDERR_FILENO )
				res = dup2( fd[1], STDERR_FILENO );
     	::close( fd[1] );
			if( res < 0 ){ printf( "#done99\n" ); exit(-1); };
	 	}
		::sleep( 1 );

		QString curDir = QDir::currentDirPath();
		QDir::setCurrent( QString( RPM_PATH ) + QString( "/RPMS/" ) );

		bool externalSelect = ( ( selected == custom || selected == upgrade ) && ps.packages
			&& ps.numPackages );

		printf( "Install type - %d\n", selected );

		int res = INST_OK;
		if( externalSelect || selected != custom ){
  		printf( "#start3\n" );
			if( !externalSelect ){
    		QString fileName = QString( RPM_PATH ) + "/base/hdlist";
    		printf( "#progress\n" );
    		res = getPackageSet( fileName );
    		printf( "#progress\n" );
    		if( res != INST_OK ){ printf( "#done1\n" ); exit(-1); };
    		fileName = QString( RPM_PATH ) + "/base/comps";
    		res = getComponentSet( fileName );
    		if( res != INST_OK ){ printf( "#done2\n" ); exit(-1); };
    		printf( "#progress\n" );
			}

  		printf( "#start1000\n" );
  		rpmReadConfigFiles( NULL, NULL );
			if( selected != upgrade )
	  		selectPackages();
  		if( selected != full ) { // it's meaningful to check full install
  			Log::logMain( 34, "Start to verify deps!" );
    		res = verifyDependencies();
				checkForX();
    		if( !externalSelect && res != INST_OK ){ // resolving deps failed
					printf( "#done3\n" ); exit(-1);
				};
				Log::logMain( 34, "Verified deps!" );
  		}
#ifndef GBLI_DEVEL
			::nice( 5 );
  		res = doInstall(); // main method
  		printf( "#progress999\n" );
			Log::logMain( 34, "Now lets free some memory for some reason ;)" );
  		freeComponentSet();
			Log::logMain( 34, "Freed memory! Still flying %-)" );
  		printf( "#progress1000\n" );
  		if( res != INST_OK ){ printf( "#done3\n" ); exit(-1); };
#endif

  		printf( "#start10\n" );
  		printf( "#progress5\n" );
			char buf[64];
			sprintf( buf, "rm -f %s/fonts.dir", NEWROOT );// hacking actually ;-)
			system( buf );
  		printf( "#progress10\n" );
		}else{
			printf( "#messageNothing to install!" );
		}

		QDir::setCurrent( curDir );
		printf( "#done0\n" );
		exit(1);
  }
	Log::logMain( 34, "runInstall pid: %d", pid );
  ::close( fd[1] );
}

static unsigned int emptyCount = 0;

void InstallSelect::showInstallationProgress( int fd )
{
  QFile f;
  if ( f.open( IO_ReadOnly, fd ) ) {    // file opened successfully
	 	QTextStream t( &f );	    	  			// use a text stream
		QString line = t.readLine();
		f.close();
    if( !line.length() ){
    	if( emptyCount < 20 ){
    		Log::logMain( 32, "Line: empty message!!!!!!!!!!!" );
    		emptyCount++;
    	}else if( emptyCount != 22 ){
    		Log::logMain( 32, "Line: TOO MUCH empty messages!!!!!!!!!!!" );
    		emptyCount = 22;
    	}
    	return;
    }else if( emptyCount > 0 )
    	emptyCount--;
    if( line.left( 4 ) != "#pro" && line.ascii()[0] != '*' ){// no progress messages
    	Log::logMain( 0, "Line: %s", line.ascii() ); // log file
    	Log::printf( 2, "Line: %s", line.ascii() );  // console
    }
		if( line.left( 6 ) == "#start" ) {//begin stage
			++iStage;
			switch( iStage ){
				case 0://prepare
  		    emit setProgressLabel( tr("Preparing") );
					break;
				case 1://install
					if( selected == base )
	  		    emit setProgressLabel( tr("Base packages") );
					else
	  		    emit setProgressLabel( tr("Packages") );
					break;
				case 2://post install
  		    emit setProgressLabel( tr("Postinstall") );
  	  	  break;
			}
    	currentProgress = 0;
			emit showProgressBar();
	    emit resetProgress();
	    maxProgress = line.right( line.length() - 6 ).toInt();
  	  emit setTotalSteps( maxProgress );
		}else
		if( line.left( 5 ) == "#done" ) {//finish stage
 		 	::close( fd );
   		int status;
   		::waitpid( pid, &status, 0 );
			QString mess;
  		switch( line.right( line.length() - 5 ).toInt()/*WIFEXITED(status)*/ ){
				case -1:	mess = "Fatal error on getting package headers."; break;
				case -2:	mess = "Fatal error on getting components."; break;
				case -3:  mess = "One or more packages could not be installed."; break;
				case 0:
				default:
					break;
  		}
			if( mess.length() ){
  		  QMessageBox::critical( 0, tr("Install failed"), tr(mess) );
				Log::logMain( 32, mess );
			}
     	delete notifier;
 			notifier = 0;
			emit hideProgressBar();
  		emit installationFinished();
			Log::logMain( 33, "Done!" );
		}else
		if( line.left( 9 ) == "#progress" ) {//show progress
			if( line.length() <= 9 )
	    	currentProgress++;
			else
				currentProgress = line.right( line.length() - 9 ).toInt();
    	if( currentProgress > maxProgress ){
				Log::logMain( 32, "Exceeding maxProgress(%d) - %d", maxProgress, currentProgress );
				currentProgress = maxProgress;
			}
     	emit setProgress( currentProgress );
		}else	if( line.left( 8 ) == "#message" ) {
			int length = line.length() - 8;
			if( length ){
				errorWindow( this, tr( line.right( length ).ascii() ) );
				Log::logMain( 32, line.right( length ).ascii() );
			}else{
				Log::logMain( 32, "Empty error message!!!!!!!!" );
			}
		}else	if( line.left( 7 ) == "#setmax" ) {
    	currentProgress = 0;
	    maxProgress = line.right( line.length() - 7 ).toInt();
  	  emit setTotalSteps( maxProgress );
		}else{
//			printf( line.ascii() );
		}
	}
	fflush( stdout );
	fflush( stderr );
}

int InstallSelect::getComponentSet( QString &a_strFileName )
{
		if( cs.numComponents ) return INST_OK;

    FILE * f;
    char buf[255];
    int inComp;
    int line = 0;
    char * start;
    char * chptr;
    int compsAlloced;
    int packagesAlloced = 0;
    component * currcomp = NULL;
    packageInfo packkey, ** pack;
    packageInfo * keyaddr = &packkey;
//    int skipMissing = 0;
		int iBase = 0, iMinimum = 0, iTypical = 0;

    cs.numComponents = 0;
    cs.base = NULL;
    cs.minimum = NULL;
		cs.typical = NULL;

    f = fopen( a_strFileName.ascii(), "r" );
    if (!f) {
			printf( "#messageCannot open components file: %s\n", a_strFileName.ascii() );
			return INST_ERROR;
    }

    /* get the version number */
    line++;
    if( !fgets(buf, sizeof(buf), f) ) {
			printf( "#messageCannot read components file: %s\n", a_strFileName.ascii() );
			fclose(f);
			return INST_ERROR;
    }

    if( strcmp(buf, "0\n") && strcmp(buf, "0.1\n") ) {
			printf( "#message%s\n", "Comps file is not version 0.1 as expected" );
			fclose(f);
			return INST_ERROR;
    }

    compsAlloced = 5;
    cs.comps = (struct component *)malloc( sizeof(*cs.comps) * compsAlloced );
		if ( cs.comps == NULL ) {
			printf( "#message%s\n", "Can`t allocate memory." );
			fclose(f);
			return INST_ERROR;
    }

    inComp = 0;
    while( fgets(buf, sizeof(buf), f) ){
			line++;

			/* remove any trailing '\n', leave chptr at the end of the string */
			chptr = buf + strlen(buf) - 1;
			if( *chptr == '\n' )
	  	  *chptr = '\0';
			else
	  	  chptr++;

			/* strip leading spaces */
			start = buf;
			while( *start && isspace(*start) ) start++;

			/* empty string */
			if( !*start ) continue;
	
			/* comment */
			if( *start == '#' ) continue;

			if( !inComp ){
		    /* first digit must be a zero or a one */
		    if (*start != '0' && *start != '1') {
					printf( "#messagebad comps file at line %d\n", line );
					continue;
		    }

		    if( compsAlloced == cs.numComponents ) {
					compsAlloced += 5;
					cs.comps = (struct component *)realloc( cs.comps, sizeof(*cs.comps) * compsAlloced );
		    }
  	
	  	  currcomp = cs.comps + cs.numComponents;
	    	currcomp->selected = (*start == '1');
		    currcomp->inmenu = true;

		    start++;
	  	  while( *start && isspace(*start) ) start++;

		    if( !strncmp(start, "--hide ", 7) ) {
					start += 7;
					while (*start && isspace(*start)) start++;
					currcomp->inmenu = false;
		    }
	
		    if( !*start ) {
					printf( "#messagemissing component name at line %d\n", line );
					continue;
		    }

		    currcomp->name = strdup( start );

		    currcomp->ps.numPackages = 0;
	  	  packagesAlloced = 10;
	    	currcomp->ps.packages = (::packageInfo **)malloc(
					sizeof( ::packageInfo ) * packagesAlloced );
		    inComp = 1;
			} else {
		    if( !strcmp(start, "end") ) {
					inComp = 0;

					if( !strcasecmp(currcomp->name, "Base") ){
						iBase = cs.numComponents;
					}else if( !strcasecmp(currcomp->name, "Typical") ){
						iTypical = cs.numComponents;
					}else if( !strcasecmp(currcomp->name, "Minimum") ){
						iMinimum = cs.numComponents;
					}

					cs.numComponents++;
		    } else {
					packkey.name = start;
					pack = (::packageInfo **)bsearch( &keyaddr, ps.packages, ps.numPackages,
						sizeof(*ps.packages), /*(void *)*/pkgCompare );
					if( !pack ) {
/*		  		  if ( !skipMissing &&
							QMessageBox::critical( this, "Error",
					      tr("package %s at line %d does not exist").arg( start ).arg( line ),
								tr("Ignore"), tr("Ignore all") ) == 1 )*/
							Log::logMain( 32, "package %s at line %d does not exist", start, line );
//						skipMissing = 1;
				    continue;
					}

					if( currcomp->ps.numPackages == packagesAlloced ){
				    packagesAlloced += 10;
				    currcomp->ps.packages = (::packageInfo **)realloc( currcomp->ps.packages,
							sizeof(::packageInfo) * packagesAlloced );
					}

          if ( currcomp->ps.packages == NULL ) {
						printf( "#message%s\n", "Can`t allocate memory." );
						fclose(f);
						return INST_ERROR;
					}

					if( currcomp->selected )
						(*pack)->selected = true;
					if( currcomp->inmenu )
						(*pack)->inmenu = true;
//if( !strcmp( currcomp->name, "Base" ) )
//  printf( "Name: %s, selected: %d\n", (*pack)->name, (*pack)->selected );fflush( stdout );
					currcomp->ps.packages[currcomp->ps.numPackages] = *pack;
					currcomp->ps.numPackages++;
		    }
			}
    }

    fclose(f);

		cs.base = cs.comps + iBase;
		cs.typical = cs.comps + iTypical;
		cs.minimum = cs.comps + iMinimum;
		Log::logMain( 33, "getComponents read %d groups", cs.numComponents );

    return INST_OK;
}

bool InstallSelect::checkForX()
{
  if( !withX )
  	for( int i = 0; i < ps.numPackages; i++ )
    	if( ps.packages[i]->selected && strstr( ps.packages[i]->name, "XF" ) ){
  			withX = true;
  			break;
  		}
	return withX;
}

void InstallSelect::freeComponentSet() {
    int i;
    struct component * currcomp;

    currcomp = cs.comps;
		if( cs.comps && cs.numComponents ){
      for (i = 0; i < cs.numComponents; i++, currcomp++ ) {
  			if( currcomp->ps.packages )
  				free( currcomp->ps.packages );
      }
		}else if( ps.packages && ps.numPackages ){
      free( ps.packages );
		}
		cs.numComponents = 0;
		ps.numPackages = 0;
}

int InstallSelect::getPackageSet( QString &a_strFileName )
{
		if( ps.numPackages ) return INST_OK;

		int noSeek = 0;
    int end = 0, type, count;
    unsigned int * sizeptr;
    Header h;
    int packagesAlloced;
    char * name, * group;
    int done = 0;
    FD_t fd;
    ps.numPackages = 0;

    fd = fdOpen( a_strFileName.ascii(), O_RDONLY, 0644 );

    if( !fd ) {
//			errorWindow( this, tr("Error opening header file") );
			printf( "#messageerror opening header file: %s", a_strFileName.ascii() );
			return INST_ERROR;
    }

    packagesAlloced = 5;
    ps.packages = (struct packageInfo **)malloc(sizeof(*ps.packages) * packagesAlloced);
  	if ( ps.packages == NULL ) {
  			printf( "#message%s\n", "Can`t allocate memory." );
  			return INST_ERROR;
  	}
    if (!noSeek) {
			count = fdLseek( fd, 0, SEEK_CUR );
			end = fdLseek( fd, 0, SEEK_END );
			fdLseek( fd, count, SEEK_SET );
    }

    while( !done ) {
			h = headerRead( fd, HEADER_MAGIC_YES );
			if (!h && noSeek) {
		    done = 1;
			} else if (!h) {
/*				errorWindow( this, tr("Error reading header at %1").arg(
			    (int)fdLseek(fd, 0, SEEK_CUR) ) );*/
				printf( "#messageError reading header at %d\n", (int)fdLseek(fd, 0, SEEK_CUR) );
		    free(ps.packages);
		    return INST_ERROR;
			} else {
	  	  headerGetEntry(h, RPMTAG_NAME, &type, (void **) &name, &count);

		    if( !headerGetEntry(h, RPMTAG_GROUP, &type, (void **) &group,	&count) ){
					group = ( char* )malloc( 16 );
					if ( group == NULL ) {
					    free(ps.packages);
						printf( "#message%s\n", "Can`t allocate memory." );
						return INST_ERROR;
					}
					strcpy( group, "(unknown group)" );
		    }else if( !strlen(group) ){
					group = ( char* )malloc( 16 );
					if( group == NULL ) {
					    free(ps.packages);
						printf( "#message%s\n", "Can`t allocate memory." );
						return INST_ERROR;
					}
					strcpy( group, "(unknown group)" );
				}

		    if (ps.numPackages == packagesAlloced) {
					packagesAlloced += 5;
					ps.packages = (struct packageInfo **)realloc( ps.packages,
						sizeof(*ps.packages) * packagesAlloced );
					if ( ps.packages == NULL ) {
						free( ps.packages );
						printf( "#message%s\n", "Can`t allocate memory." );
						return INST_ERROR;
					}

		    }

	  	  ps.packages[ps.numPackages] =
					(struct packageInfo *)malloc( sizeof(struct packageInfo) );
			  if ( ps.packages[ps.numPackages] == NULL ) {
    			free( ps.packages );
    			printf( "#message%s\n", "Can`t allocate memory." );
    			return INST_ERROR;
			  }

	  	  ps.packages[ps.numPackages]->h = h;
	    	ps.packages[ps.numPackages]->selected = false;
//		    ps.packages[ps.numPackages]->manuallySelected = false;

		    if (headerGetEntry(h, RPMTAG_SIZE, &type, (void **) &sizeptr,	&count))
					ps.packages[ps.numPackages]->size = *sizeptr;
		    else
					ps.packages[ps.numPackages]->size = 0;

		    ps.packages[ps.numPackages]->inmenu = false/*!skipPackage(name)*/;
		    ps.packages[ps.numPackages]->name = name;
		    ps.packages[ps.numPackages]->group = group;
		    ps.packages[ps.numPackages]->item = NULL;
	  	  headerGetEntry( h, FILENAME_TAG, &type,
		     (void **) &ps.packages[ps.numPackages]->data,
		     &count );
		    ps.numPackages++;
			}
			if (!noSeek) {
		    if (end <= fdLseek(fd, 0, SEEK_CUR))
					done = 1;
			}
    }

    Log::logMain( 33, "getPackages read %d headers", ps.numPackages );

    pkgSort();

    fdClose(fd);

    return INST_OK;
}

bool InstallSelect::skipPackage( char * name )
{
/*  char ** item;

  for( item = skipList; *item; item++ ) {
		if( !strcmp( *item, name ) ) return true;
  }*/
  return false;
}

void InstallSelect::pkgSort()
{
    int i;
    char *name;

    qsort( ps.packages, ps.numPackages, sizeof(*ps.packages), pkgCompareVer );

    name = ps.packages[0]->name;
    if (!name) {
       ps.numPackages = 0;
       return;
    }
    for (i = 1; i < ps.numPackages; i++) {
       if (!ps.packages[i]->name) break;
       if (!strcmp(ps.packages[i]->name, name))
			   ps.packages[i]->name = NULL;
       else
	  		 name = ps.packages[i]->name;
    }

    qsort(ps.packages, ps.numPackages, sizeof(*ps.packages), pkgCompareVer );

    for (i = 0; i < ps.numPackages; i++)
       if (!ps.packages[i]->name) break;
    ps.numPackages = i;
}

void InstallSelect::createDirs()
{
    ::mkdir( "/mnt/root/dev", 0755 );
    ::mkdir( "/mnt/root/etc", 0755  );
    ::mkdir( "/mnt/root/tmp", 01775 );
    ::mkdir( "/mnt/root/var", 0755  );
    ::mkdir( "/mnt/root/var/tmp", 01755 );
    ::mkdir( "/mnt/root/var/lib", 0755 );
    ::mkdir( "/mnt/root/var/lib/rpm", 0755 );
    ::mkdir( "/mnt/root/proc", 0755 );
    ::mkdir( "/mnt/root/boot", 0755 );
    ::mkdir( "/mnt/root/boot/grub", 0755 );
    ::mkdir( "/mnt/root/usr", 0755 );
    ::mkdir( "/mnt/root/usr/opt", 0755 );
}

static void rpmerror(void)
{
  int code;

  code = rpmErrorCode();
	char buf[128];
	buf[0] = 0;
	switch( code ){
		case RPMERR_UNLINK:
		case RPMERR_RMDIR:
			break;
		case RPMERR_SCRIPT:
			sprintf( buf, "RPM error: %s, RPMERR_SCRIPT\n", rpmErrorString() );
			break;
		default:
			sprintf( buf, "RPM error: %s, %d\n", rpmErrorString(), code );
	}
	if( buf[0] )
 	  printf( buf );
}

int InstallSelect::verifyDependencies(){

    rpmdb db = NULL;
    rpmTransactionSet rpmdeps;
    int i;
    struct rpmDependencyConflict * conflicts;
    struct packageInfo * package;
    int numConflicts, numProblems;
    rpmErrorCallBackType old;

    if( !QFile( "/mnt/root/var/lib/rpm/packages.rpm" ).exists() ) {
			rpmSetVerbosity( RPMMESS_FATALERROR );// we don't need db really
			old = rpmErrorSetCallback( rpmerror/*emptyErrorCallback*/ );
			if( rpmdbOpen( NEWROOT, &db, O_RDWR | O_CREAT, 0644 ) )
	  	  db = NULL;
			rpmErrorSetCallback( old );
			rpmSetVerbosity( RPMMESS_NORMAL );
    }else{
			printf( "DB already exists!\n" );
			rpmdbOpen( NEWROOT, &db, O_RDWR, 0644 ); //Try to check if is reasonable string???
		}

    rpmdeps = rpmtransCreateSet( db, NULL );
		printf( "#progress\n" );

    for (i = 0; i < ps.numPackages; i++) {
			if( ps.packages[i]->selected )
	  	  rpmtransAddPackage( rpmdeps, ps.packages[i]->h, NULL,
			    ps.packages[i], 0, NULL );
			else
	  	  rpmtransAvailablePackage( rpmdeps, ps.packages[i]->h,
			    ps.packages[i] );
    }
		printf( "#progress\n" );

//printf( "Packs: %d, comps: %d\n", ps.numPackages, cs.numComponents );
    rpmdepCheck( rpmdeps, &conflicts, &numConflicts );
		printf( "#progress\n" );

    rpmtransFree(rpmdeps);
    if( db ) rpmdbClose(db);
		printf( "#progress\n" );

    /* XXX This is a hack. rpmlib seems to have problems in the conflicts
       stuff */
    numProblems = 0;
    for( i = 0; i < numConflicts; i++ ) {
			if( conflicts[i].sense == rpmDependencyConflict::RPMDEP_SENSE_REQUIRES )
				numProblems++;
    }

    if( !numProblems )
			return INST_OK;

		int count = 0;
		// Select required packages
 		for (i = 0; i < numConflicts; i++) {
   	  package = (struct packageInfo *)conflicts[i].suggestedPackage;
 	    if( package && !package->selected ){
				printf( "Select required package: %s (%s)\n", package->name, package->group );
				package->selected = true;
				count++;
			}
 		}

		printf( "Selected %d required packages!\n", count );

		// Free problems
 		rpmdepFreeConflicts( conflicts, numConflicts );

		printf( "#progress\n" );
 		return INST_OK;
}

//static bool flag1 = false, flag2 = false, flag3 = false, flag4 = false;

static void * installCallback( const Header h, const rpmCallbackType what,
			 const unsigned long amount, const unsigned long total,
			 const void * pkgKey, void * data ) {
  void * rc = NULL;
  struct callbackInfo * cbi = (struct callbackInfo *)data;
  struct packageInfo * pkg = (struct packageInfo *)pkgKey;
	long double newProgress = 0;

  switch (what) {
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_UNINST_START:
//printf( "Callback: trans start: total %d, amount %d!\n", (int)total, (int)amount );
			break;
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_UNINST_PROGRESS:
//printf( "Callback: trans progress: scale %d, total %d, amount: %d\n", (int)total, (int)amount );
//			printf( "#progress%d\n", (int)amount );
			break;
    case RPMCALLBACK_TRANS_STOP:
    case RPMCALLBACK_UNINST_STOP:
//printf( "Callback: trans stop!\n" );
//			printf( "#progress30\n" );
			break;
    case RPMCALLBACK_INST_START:
//printf( "Callback: INST_START!\n" );
			curTemp = 0;
//			printf( "#setmax%d\n", 100 );
			break;
    case RPMCALLBACK_INST_PROGRESS:
//printf( "CB_INST_PROGRESS total %d, amount %d, size %d, cur %d, tsize %d!\n",
//				(int)total, (int)amount, (int)pkg->size, (int)curInstalled, (int)cbi->totalsize );
			if( curTemp++ < 20 ) break;
			curTemp = 0;
			newProgress = ((long double)pkg->size * (long double)amount) /
										 (long double)total;
			newProgress += (long double)curInstalled;
			newProgress *= (long double)968 / (long double)cbi->totalsize;
			newProgress += 30;
			printf( "#progress%d\n", (int)newProgress );
			break;
    case RPMCALLBACK_INST_CLOSE_FILE:
//printf( "Callback: INST_CLOSE_FILE!\n" );
			fdClose( cbi->fd );
			curInstalled += pkg->size;
/*			if( !flag1 && QFileInfo( "/mnt/root/etc/profile.d/qt.sh" ).exists() ){
				printf( "qt.sh!!!!!!!!!!!!!! by %s\n", (char *)pkg->data );
				flag1 = true;
			}*/
/*			if( !flag2 && QFileInfo( "/mnt/root/etc/rc.d/rc5.d/S85nessusd" ).exists() ){
				printf( "nessusd added!!!!!!!!!!!!!!! by %s\n", (char *)pkg->data );
				flag2 = true;
			}
			if( !flag3 && QFileInfo( "/mnt/root/etc/rc.d/rc5.d/S85gnu-pop3d" ).exists() ){
				printf( "gnu-pop3d added!!!!!!!!!!!!!!! by %s\n", (char *)pkg->data );
				flag3 = true;
			}
			if( !flag4 && QFileInfo( "/mnt/root/etc/rc.d/rc5.d/S98mysql" ).exists() ){
				printf( "mysqld added!!!!!!!!!!!!!!! by %s\n", (char *)pkg->data );
				flag4 = true;
			}*/
			break;
    case RPMCALLBACK_INST_OPEN_FILE:
//printf( "Callback: INST_OPEN_FILE - %s\n", pkg->name );
	    static char realName[300];
			sprintf( realName, "%s/RPMS/%s", RPM_PATH, (char *)pkg->data );
	    printf( "%s %s.\n",
 		    cbi->upgrade ? "Upgrading" : "Installing", realName );

    	cbi->fd = fdOpen( realName, O_RDONLY, 0/*0666*/);
    	if (!cbi->fd) {
        int olderrno = errno;
				Log::logMain( 32, "cannot open RPM file %s: %s", pkg->data,
	    		strerror(olderrno) );
        return NULL;
    	}

    	cbi->lastFile = realName;
    	rc = cbi->fd;
   		break;
    }
    return rc;
}

void InstallSelect::selectPackages()
{
	if( selected == upgrade ) return;
	if( selected == custom ) return;

	int i;
	bool full_select = selected == full;

	// Select something
  for( i = 0; i < ps.numPackages; i++ )
		ps.packages[i]->selected = full_select;
	printf( "#progress\n" );

	if( full_select ) return;// everything already selected

	// Select most needed
  for( i = 0; i < ps.numPackages; i++ )
  	if( !strcmp(ps.packages[i]->name, "basesystem") ||
			  !strcmp(ps.packages[i]->name, "grub") )
			ps.packages[i]->selected = true;
	printf( "#progress\n" );

	// Select 'Base'
  for ( i = 0; i < cs.base->ps.numPackages; i++)
		cs.base->ps.packages[i]->selected = true;
	printf( "Selected %d packages (base)\n", cs.base->ps.numPackages );
	printf( "#progress\n" );

	// Select 'Minimum'
  for ( i = 0; i < cs.minimum->ps.numPackages; i++)
		cs.minimum->ps.packages[i]->selected = true;
	printf( "Selected %d packages (minimum)\n", cs.minimum->ps.numPackages );
	printf( "#progress\n" );

	// Select 'Typical'
	if( selected == typical ){
    for ( i = 0; i < cs.typical->ps.numPackages; i++)
			cs.typical->ps.packages[i]->selected = true;
		printf( "Selected %d packages (typical)\n", cs.typical->ps.numPackages );
		printf( "#progress\n" );
	}
}

int InstallSelect::doInstall()
{
    int i;
		int totalNumPackages = 0;
		int totalSizePackages = 0;
    rpmdb db;
    FD_t lfFd;
//    char * path;
    rpmTransactionSet trans;
    rpmProblemSet probs;
    struct callbackInfo cbi;
		int syslogPID = 0;
//		FILE *spec_log;

		//save current time
		struct timeval curtime, time;
    gettimeofday( &curtime, NULL );
		gettimeofday( &time, NULL );
		time.tv_sec -= 86400;
// in case someone invents time machine and travels
// back to 0 time to install Best Linux... hence we have to check
// the condition to be sure
		if( time.tv_sec < 0 )
			time.tv_sec = 0;
    settimeofday( &time, NULL );

//    path = (char *)alloca( strlen(NEWROOT) + 20 );
//    sprintf( path, "%s/tmp/install_spec.log", NEWROOT );
//    lfFd = fdOpen( path, O_RDWR | O_CREAT | O_TRUNC, 0600 );
		lfFd = fdDup( Log::mainlog->_fileno );
		setlinebuf( Log::mainlog );

Log::logMain( 32, "Passed checkpoint, _fileno %d !", Log::mainlog->_fileno );
/*    if( lfFd ) {
    	spec_log = fdopen( fdFileno(lfFd), "w" );
if( !spec_log )
printf( "failed to open logfile :-(\n" );
    	setlinebuf( spec_log );
printf( "opened %s\n", path );
    } else {
printf( "failed to open %s :-(\n", path );
			printf( "#message%s \n", tr("Failed to open %1. No install log will be kept.").arg(path).ascii() );
    }*/

    syslogPID = handleSyslogSocket( NEWROOT );
	
//rpmSetVerbosity( RPMMESS_DEBUG ); //extra debug ;-)
    rpmErrorSetCallback( rpmerror );
printf( "#progress\n" );

    /* FIXME: we ought to read /mnt/usr/lib/rpmrc if we're in the midst of an
       upgrade, but it's not obvious how to get RPM to do that. */
    /* if we set netshared path to "" then we get no files installed
    addMacro(&globalMacroContext, "_netsharedpath", NULL,
	     netSharedPath ? netSharedPath : "" , RMIL_RPMRC); */

    rpmdbInit( NEWROOT, 0644 );
printf( "#progress\n" );

		int res = 0;
    if( (res = rpmdbOpen( NEWROOT, &db, O_RDWR | O_CREAT, 0644 )) ) {
	    Log::logMain( 32, "rpmdbOpen res: %d, error: %d, %s\n", res, rpmErrorCode(), rpmErrorString() );
			printf( "#messageFatal error opening RPM database\n" );
	    settimeofday( &curtime, NULL );
    	return INST_ERROR;
    }
    printf( "opened rpm database\n" );
		::sync();

printf( "#progress\n" );

    trans = rpmtransCreateSet( db, NEWROOT );
printf( "#progress\n" );

    rpmtransSetScriptFd( trans, lfFd );
		::sync();

    totalNumPackages = 0, totalSizePackages = 0;

    for( i = 0; i < ps.numPackages; i++ ) {
    	if( !strcmp(ps.packages[i]->name, "basesystem") ||
				  (!strcmp(ps.packages[i]->name, "grub") && selected!=custom) ||//make it sure once more
          ps.packages[i]->selected ) {
//intf( "Add package: %s\n", ps.packages[i]->name );
   	  	rpmtransAddPackage( trans, ps.packages[i]->h, NULL,
		    	ps.packages[i], 0/*upgrade*/, NULL );

  	    totalSizePackages += ps.packages[i]->size;
			  totalNumPackages++;
    	}
    }

printf( "#progress\n" );
printf( "Added packages: %d of total %d!\n", totalNumPackages, ps.numPackages );

		if( Log::iDebugLevel > 1 ){
  	  Log *strangefiles = NULL;
    	strangefiles = new Log( false, "/mnt/root/tmp/not_selected_packages.log" );
    	if( strangefiles ){
        for( i = 0; i < ps.numPackages; i++ ) {
        	if( !ps.packages[i]->selected ) {
     				strangefiles->log( 0, "%s  (%s)\n", ps.packages[i]->name, ps.packages[i]->group );
        	}
        }
    		strangefiles->close();
    		printf( "Logged missing files!\n" );
    	}else{
    		printf( "Logging missing files failed!!!\n" );
    	}
		}

    if( rpmdepOrder(trans) ) {
     	rpmdbClose( db );
     	rpmtransFree( trans );
			printf( "#message%s\n", tr("Error ordering package list: %1").arg( rpmErrorString() ).ascii() );
	    settimeofday( &curtime, NULL );
     	return INST_ERROR;
    }
printf( "#progress\n" );
printf( "Ordered packages!\n" );

    cbi.upgrade = 0/*upgrade*/;
    cbi.totalnum = totalNumPackages;
    cbi.totalsize = totalSizePackages;

    /* mount /proc in the instroot */
		system( "/usr/bin/umount /proc" );
		char cmd[128];
    sprintf( cmd, "/usr/bin/mount -t proc proc %s/proc", NEWROOT );
		res = system( cmd );
printf( "system reply to mounting proc: %d\n", res );

		// Now lets try to take-off ;-)
   	rpmRunTransactions( trans, installCallback, &cbi, NULL, &probs, 0, ~0 );

		::sync();
		sleep( 1 );
    sprintf( cmd, "/usr/bin/umount %s/proc", NEWROOT );
		system( cmd );
		system( "/usr/bin/mount -t proc proc /proc" );

printf( "#progress\n" );
printf( "Installed packages!\n" );

    fdClose( lfFd );

    rpmProblemSetFree( probs );

    rpmdbClose( db );

    rpmtransFree( trans );

    printf( "rpm database closed\n" );

    if( syslogPID > 0 ){
			::kill( syslogPID, SIGKILL );
			::waitpid( syslogPID, NULL, 0 );
	  }
		::sync();

printf( "#progress\n" );

    settimeofday( &curtime, NULL );
//printf( "Finished installing packages!\n" );

		setvbuf( Log::mainlog, (char *)NULL, _IOLBF, 0 );

    return 0;
}

#ifdef TEST12345
int InstallSelect::doInstall_hack()
{
		system( "/usr/bin/rpm --initdb --root /mnt/root" );

		char cmd[65530];
		memset( cmd, 0, sizeof(65530) );
		cmd[0] = ' ';
    for( int i = 0; i < ps.numPackages; i++ )
			if( ps.packages[i]->selected )
				sprintf( cmd, "%s %s*.rpm", cmd, ps.packages[i]->name );
		char cmd1[65530];
		memset( cmd1, 0, 65530 );
		sprintf( cmd1, "/bin/sh -c \"cd /mnt/install/packages/RPMS/;/usr/bin/rpm -i --force --nodeps --root /mnt/root %s\"", cmd );
		printf( "#progress5\n" );
		int res = system( cmd1 );
		printf( "#progress5\n" );
		printf( "Install result: %d\n", res );
		return INST_OK;
}
#endif



































































