/***************************************************************************
                               lkeyboard.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "lkeyboard.h"
#include "linlinehelp.h"
#include "configfile.h"
#include "llanguage.h"

#include <qlistbox.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qapplication.h>

#include <qfile.h>
#include <qtextstream.h>
#include <unistd.h>
#include <sys/wait.h>

struct keyboardsTable {
    char * name, * lang, * keyboard;
} defaultKeyboards[] = {
    { "Belgian", "be", "be-latin1" },
    { "Belgian (be2-latin1)", "be", "be2-latin1" },
    { "Bulgarian", "bg", "bg" },
    { "Canadian", "ca", "ca" },
    { "Czechoslovakian", "cs", "cz-lat2" },
    { "Czechoslovakian (cz-lat2-prog)", "cs", "cz-lat2-prog" },
    { "Danish", "dk", "dk" },
    { "Danish (dk-latin1)", "dk", "dk-latin1" },
		{ "Estonian", "et", "et" },
    { "Finnish", "fi", "fi" },
    { "Finnish (fi-latin1)", "fi", "fi-latin1" },
    { "French", "fr", "fr" },
    { "French (fr-latin0)", "fr", "fr-latin0" },
    { "French (fr-latin1)", "fr", "fr-latin1" },
    { "French (fr-pc)", "fr", "fr-pc" },
    { "German", "de", "de" },
    { "German (de-latin1)", "de", "de-latin1" },
    { "German (de-latin1-nodeadkeys)", "de", "de-latin1-nodeadkeys" },
    { "Hungarian", "hu", "hu" },
    { "Hungarian (fr_CH)", "fr_CH", "fr_CH" },
    { "Hungarian (hu101)", "fr_CH", "hu101" },
    { "Italian", "it", "it" },
    { "Italian (it-ibm)", "it", "it-ibm" },
    { "Italian (it2)", "it", "it2" },
    { "Japanese", "jp", "jp106" },
    { "Norwegian", "no", "no" },
    { "Norwegian (no-latin1)", "no", "no-latin1" },
    { "Polish", "pl", "pl" },
    { "Portugese", "pt", "pt-latin1" },
		{ "Russian (KOI8-R)", "ru", "ru" },
		{ "Russian (ru1)", "ru", "ru1" },
		{ "Russian (ru2)", "ru", "ru2" },
		{ "Russian (ru-ms)", "ru", "ru-ms" },
		{ "Russian (ru_win)", "ru", "ru_win" },
		{ "Russian (ru-cp1251)", "ru", "ru-cp1251" },
    { "Spanish", "es", "es" },
    { "Swedish", "se", "se-latin1" },
		{ "Swiss German", "de_CH", "de_CH" },
		{ "Thai", "th", "th" },
    { "Turkish", "tr", "trq" },
    { "United Kingdom", "gb", "us" },
    { "U.S. English", "us", "us" } };

/*          "fr-latin0"         : ('pc102', 'fr'),
            "fr-latin1"         : ('pc102', 'fr'),
            "fr-pc"             : ('pc102', 'fr'),
            "fr"                : ('pc102', 'fr'),
            "cf"                : ('pc102', 'cf'),
            "cz-lat2-prog"      : ('pc102', 'cs'),
            "cz-lat2"           : ('pc102', 'cs'),
            "dk-latin1"         : ('pc102', 'dk'),
            "dk"                : ('pc102', 'dk'),
            "es"                : ('pc102', 'es'),
            "fi-latin1"         : ('pc102', 'fi'),
            "fi"                : ('pc102', 'fi'),
            "hu101"             : ('pc102', 'hu'),
            "it-ibm"            : ('pc101', 'it'),
            "it"                : ('pc102', 'it'),
            "it2"               : ('pc102', 'it'),
            "jp106"             : ('jp106', 'jp'),
            "no-latin1"         : ('pc102', 'no'),
            "no"                : ('pc102', 'no'),
            "pl"                : ('pc102', 'pl'),
            "pt-latin1"         : ('pc102', 'pt'),
            "ru-cp1251"         : ('pc102', 'ru'),
            "ru-ms"             : ('microsoft', 'ru'),
            "ru"                : ('pc102', 'ru'),
            "ru1"               : ('pc102', 'ru'),
            "ru2"               : ('pc102', 'ru'),
            "ru_win"            : ('pc105', 'ru'),
            "se-latin1"         : ('pc102', 'se'),
            "us"                : ('pc101', 'us'),
            "de-latin1-nodeadkeys" : ('pc102', 'de'),
            "de-latin1"         : ('pc102', 'de'),
            "de"                : ('pc102', 'de'),
            "fr_CH-latin1"      : ('pc102', 'fr_CH'),
            "fr_CH"             : ('pc102', 'fr_CH'),
            "hu"                : ('pc102', 'fr_CH') */

/*U.S. English#us
Belgian#be
Bulgarian#bg
Czechoslovakian#cs
Swiss German#de_CH
Danish#dk
Spanish#es
German#de
Estonian#et
Finish#fi
French#fr
Swiss French#sf
United Kingdom#gb
Hungarian#hg
Italian#it
Japanese#jp
Norwegian#no
Polish#pl
Portugese#pt
Russian#ru
Swedish#se
Thai#th */

struct modelsTable {
    char * name, * type;
} keyboardModels[] = {
  { "Generic 101-key PC", "pc101" },
  { "Generic 102-key Intl PC", "pc102" },
  { "Generic 104-key PC", "pc104" },
	{ "Dell 101-key PC", "dell101" },
  { "Everex STEPnote", "STEPnote" },
	{ "Keytronic FlexPro", "FlexPro" },
  { "Microsoft Natural", "microsoft" },
  { "Northgate OmniKey 101", "omnikey101" },
  { "Winbook Model XP5", "XP5" },
	{ "Japanese 106-key", "jp106" } };

LKeyboard::LKeyboard( const QString& language, QWidget * parent, const char * name )
    : QWidget( parent, name )
{
		if( !QDir( "/var/lib/xkb" ).exists() ) {
	    mkdir( "/var", 0755 );
  	  mkdir( "/var/lib", 0755 );
    	mkdir( "/var/lib/xkb", 01755 );
		}
		
    lang = language;
    QHBoxLayout * lh = new QHBoxLayout( this, 0, 6 );

    QVBoxLayout * l = new QVBoxLayout( 6 );
		lh->addStretch( 1 );
    lh->addLayout( l, 8 );

    QLabel* label = new QLabel( tr("Select Model:"), this );
		l->addSpacing( 10 );
    l->addWidget( label );
    listModel = new QListBox( this );
    l->addWidget( listModel, 10 );

    label = new QLabel( tr("Select Layout:"), this );
    l->addWidget( label );
    listLayout = new QListBox( this );
    l->addWidget( listLayout, 10 );

    label = new QLabel( tr("Test here:"), this );
    l->addWidget( label );
    editTest = new QLineEdit( this );
    l->addWidget( editTest );
		l->addSpacing( 10 );

		lh->addStretch( 1 );

    setLayout = -1;
    setModel = -1;

    listModel->setFocus();

    initialized = FALSE;
}

LKeyboard::~LKeyboard()
{
}

void LKeyboard::showEvent( QShowEvent * )
{
    init();
}

void LKeyboard::hideEvent( QHideEvent * )
{
    set( NULL /*"us"*/ );
}

void LKeyboard::init()
{
    if (initialized)
			return;
    initialized = TRUE;

		int iMax = sizeof( keyboardModels ) / sizeof( struct modelsTable );
		for( int i = 0; i < iMax; i++ ){
			listModel->insertItem( QString( keyboardModels[i].name ) );
		}

		iMax = sizeof( defaultKeyboards ) / sizeof( struct keyboardsTable );
		for( int i = 0; i < iMax; i++ ){
			listLayout->insertItem( QString( defaultKeyboards[i].name ) );
		}

    listModel->setCurrentItem( 1 );
    listLayout->setCurrentItem( 0 );

	  int numLanguages = sizeof(languages) / sizeof( struct langInfo );
  	for( int i = 0; i < numLanguages; i++ )
    	if( !strcasecmp( languages[i].lang, lang ) ){
				short_lang = (char*)languages[i].key;
				int k = 0;
        for( ; k < iMax; k++ )
					if( !strcasecmp( defaultKeyboards[k].lang, short_lang ) ){
				    listLayout->setCurrentItem( k );
						break;
					}
				if( k == iMax )
			    listLayout->setCurrentItem( iMax-1 );
				break;
			}
    editTest->installEventFilter( this );
}


bool LKeyboard::eventFilter( QObject *o, QEvent * e)
{
    if ( o == editTest && e->type() == QEvent::FocusIn )
			set( NULL );
    return FALSE;
}

void LKeyboard::set( char *a_layout )
{
    if ( listLayout->currentItem() == setLayout && listModel->currentItem() == setModel )
			return;
    setModel = listModel->currentItem();
    setLayout = listLayout->currentItem();

		char *layout = a_layout; // override choosen
		if( !layout )
			layout = (char*)defaultKeyboards[setLayout].lang;
    QApplication::flushX();
    int pid = ::fork();
    if (pid == 0) {
			execl("./extrabin/setxkbmap", "./extrabin/setxkbmap",
	      "-rules", "xfree86",
	      "-model", keyboardModels[setModel].type,
	      "-layout", layout,
	      "-display","127.0.0.1:1", 0);
			exit(1);
    }
printf( "LKeyboard::set pid: %d\n", pid );
    ::waitpid(pid, NULL, 0);
}

QString LKeyboard::layout()
{
    return defaultKeyboards[setLayout].lang;
}

QString LKeyboard::model()
{
    return QString( keyboardModels[setModel].type );
}

void LKeyboard::finish( const char * directory )
{
	char buf[64];
	sprintf( buf, "%s/sysconfig", (char*)directory );
	::mkdir( buf, 0755 );
	ConfigFile config( directory, "/sysconfig/keyboard" );
  FILE *fp = config.open( "a" );

	if( fp ){
		fprintf( fp, "KEYTABLE=\"%s\"\n", defaultKeyboards[setLayout].keyboard );
		fclose( fp );
	}		
}
















