/***************************************************************************
                              llanguage.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		 : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			 : http://www.bestlinux.net
    email		 : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LLANGUAGE_H
#define LLANGUAGE_H
#include <qwidget.h>

class QButtonGroup;
class LInlineHelp;
class QListBox;

struct langInfo {
   char * lang, * key, * font, * map, * lc_all, *charset;
} ;

static const struct langInfo languages[] = {
	{ "English",    "en",   "",             "",       "en_US", "iso-8859-1" },
  { "Estonian",   "et",   "lat2u-16",     "",       "et_EE", "iso-8859-1" },
  { "Finnish",    "fi",   "lat2-sun16",   "iso02",  "fi_FI", "iso-8859-1" },
  { "French",     "fr",   "lat0-sun16",   "iso15",  "fr_FR", "iso-8859-1" },
  { "German",     "de",   "lat0-sun16",   "iso15",  "de_DE", "iso-8859-1" },
//  { "Hungarian",  "hu",   "lat2-sun16",   "iso02",  "hu_HU", "iso-8859-2" },
//  { "Icelandic",  "is",   "lat0-sun16",   "iso15",  "is_IS", "iso-8859-1" },
//  { "Italian",    "it",   "lat0-sun16",   "iso15",  "it_IT", "iso-8859-1" },
//  { "Norwegian",  "no",   "lat0-sun16",   "iso15",  "no_NO", "iso-8859-1" },
//  { "Romanian",   "ro",   "lat2-sun16",   "iso02",  "ro_RO", "iso-8859-2" },
  { "Russian",    "ru",   "Cyr_a8x16",    "koi2alt","ru_RU.KOI8-R", "koi8-r" },
  { "Spanish",    "es",   "lat2-sun16",   "iso02",  "es_ES", "iso-8859-1" },
  { "Swedish",    "sv",   "lat2-sun16",   "iso02",  "sv_SE", "iso-8859-1" },
//  { "Ukrainian", "uk_UA", "RUSCII_8x16",  "koi2alt","uk_UA", "koi8-u"     }
   };

class LLanguage: public QWidget
{
    Q_OBJECT
public:
    LLanguage( QWidget * parent, const char * name = 0 );
    ~LLanguage();

    QString language() const;
		int getLangIndex(){ return selected; };

protected:
    void showEvent( QShowEvent * );
    void hideEvent( QHideEvent * );

private slots:
    void setSelected( int );

private:
		QListBox *lboxLangs;
    LInlineHelp* inlineHelp;
    int selected;
};
#endif





