/***************************************************************************
                               ltemplate.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qdict.h>
#include <qtextstream.h>
#include <qregexp.h>
#include <stream.h>

#include "ltemplate.h"


LTemplate::LTemplate(QString temp)
  : tpl(temp), tokens(17,FALSE)
{
}


void LTemplate::addToken(const char *token, const char *value)
{
  tokens.insert(token,strdup(value));
}


void LTemplate::write(QString target)
{
  // try to open the template
  if (tpl.open(IO_ReadOnly))
    {
      QTextStream input(&tpl);
      
      // try to open the output
      QFile outfile(target);
      if (outfile.open(IO_WriteOnly))
	{
	  QTextStream output(&outfile);

	  // copy the file
	  while (!input.eof())
	    {
	      QString line = input.readLine();
	      output << substitute(line) << endl;
	    }

	  outfile.close();
	}
	  
      tpl.close();
    }
}


QString LTemplate::substitute(QString line)
{
 QDictIterator<char> it(tokens);
  while (it.current())
    {
      QString exp("${%1}");
      exp = exp.arg(it.currentKey());
      QRegExp regexp(exp,FALSE);
      line = line.replace(regexp, it.current());
      ++it;
    }

  return line;
}



