/***************************************************************************
                              ltimezone.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LTIMEZONE_H
#define LTIMEZONE_H
#include <qwidget.h>
#include <qpixmap.h>
#include <qlist.h>
#include <qdict.h>
class QListView;
class QRadioButton;
class QListViewItem;
class QLabel;
class QComboBox;

class LZoneInfo
{
public:
    LZoneInfo( const QString& line, bool coords = TRUE );
    ~LZoneInfo(){};

    double x;
    double y;
    QString country;
    QString city;
    QString comment;
    bool coordinates;
};

class LWorld: public QWidget
{
    Q_OBJECT
public:
    LWorld( QWidget * parent = 0, const char * name = 0 );
    ~LWorld();

    void readInZoneInfo( QComboBox* zone );

    LZoneInfo* nearestZone( int x, int y);

    QString getComment( const QString& zone);

signals:
    void highlighted( const QString& );
    void selected( const QString& );

 public slots:
    void highlight( const QString& );

protected:
    void paintEvent( QPaintEvent* );
    void resizeEvent( QResizeEvent* );
    void mouseMoveEvent( QMouseEvent* );
    void mouseReleaseEvent( QMouseEvent * );
    void enterEvent( QEvent * );
    void leaveEvent( QEvent * );


private:

    QPixmap worldpm;
    int w;
    int h;
    int relw;
    int relh;
    int ox;
    int oy;

    QList <LZoneInfo> zones;
    QDict <LZoneInfo> zoneDict;
    LZoneInfo* high;

    QLabel* cityIndicator;

};

class LTimeZone: public QWidget
{
    Q_OBJECT
public:
    LTimeZone( const QString& language, QWidget * parent = 0,
	       const char * name = 0 );
    ~LTimeZone();

    QString timezone();
		void finish(const char *);

public slots:
    void setTimezone( const QString& );
    void prepare();

protected:
    void showEvent( QShowEvent* );

private:
    LWorld*  world;
    bool prepared;

    QComboBox* comboZone;
    QLabel*  comment;

public:
    QRadioButton* radioLocaltime;
    QRadioButton* radioGMT;

private:
    QString lang;
};


#endif

