/***************************************************************************
                                upgradepage.h
                             -------------------
    begin                : Tue Jan 4 2000
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef UPGRADEPAGE_H
#define UPGRADEPAGE_H

#include "config.h"
#include "hash.h"

#include <qwidget.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <rpm/rpmlib.h>
#include <rpm/header.h>

class pkgSet;
class InstallSelect;


class UpgradePage : public QWidget {
   Q_OBJECT
public:
	UpgradePage( QWidget *parent, const char *name=0 );
	~UpgradePage();
	enum { install = 0, upgrade };

	int type;

	int startUpgrade( InstallSelect *a_install );

private:
	void setSelected( int a_i );

	void compareFileList( int availFileCount, char **availFiles,
			    int installedFileCount, char **installedFiles );
	void addLostFiles();
	int findPackagesWithObsoletes();
	int findUpgradePackages();
	int removeMovedFilesAlreadyHandled();
	int findPackagesWithRelocatedFiles();
	void printCount();
	int unmarkPackagesAlreadyInstalled();
	int mountFileSystem();

	QButtonGroup *gb;
	QRadioButton *rbInstall;
	QRadioButton *rbUpgrade;

	rpmdb db;
	pkgSet *psp;
	struct hash_table *ht;

};
#endif


