/*
 * Mouse detection
 *
 * Copyright (C) 2000, SOT Finnish Software Engineering Ltd.
 */

#ifndef MDETECT_H
#define MDETECT_H

struct device {
	struct device *	next;
	char		name[64];
	int		fd;
	struct mouse *	driver;
	unsigned long	timeout;	/* When packet should be complete */
};

struct mouse {
	const char *	name;
	int		(*init)(struct device *, struct mouse *);
	int		(*packet)(struct device *,
					struct mouse *,
					unsigned char);
	int		(*timeout)(struct device *);
	const char *	(*report)(struct mouse *);

	struct mouse *	next;
	struct mouse *	alt;
	void *		data;

	unsigned char	buffer[256];
	unsigned int	cur, got;
	unsigned int	total;		/* total byte count */
	unsigned int	good;
	unsigned int	bad;

	unsigned int	flags;
#define FLAG_MS_WEIRDO	0x01

	unsigned int	buttons;
#define BUTTON_RIGHT	0x01
#define BUTTON_MIDDLE	0x02
#define BUTTON_LEFT	0x04
	int		dx, dy;
	int		lx, ly;		/* last dx/dy, for 2nd derivative */
};

struct mouse *		get_mouse(const char *);
int			send_event(struct mouse *);
void			serialdev_init(struct device *);

#endif /* MDETECT_H */
